#include <iostream>  
using namespace std;


bool is_mc_nugget(int n)
{ // return true iff n is a Mc Nugget Number
  // i.e., was can purchase exactly this number of Chicken Nuggets,
  // where the atomic orders are 4, 6, 9, 20

	cout << " " << n << endl;

	if ((n == 0) || (n == 4) || (n == 6) || (n == 9) || (n == 20))
		return true;

	if (n < 4)
		return false;

	if (is_mc_nugget(n - 4))
		return true;

	if (is_mc_nugget(n - 6))
		return true;
	
	if (is_mc_nugget(n - 9))
		return true;

	if (is_mc_nugget(n - 20))
		return true;


	return false;
}


bool is_mc_nugget2(int n)
{ // return true iff n is a Mc Nugget Number
  // i.e., was can purchase exactly this number of Chicken Nuggets,
  // where the atomic orders are 4, 6, 9, 20
  // (We can skip the 20 as it is unnecessary.)

	cout << " " << n << endl;

	if ((n == 0) || (n == 4) || (n == 6) || (n == 9))
		return true;

	if (n < 4)
		return false;

	if (is_mc_nugget2(n - 4))
		return true;

	if (is_mc_nugget2(n - 6))
		return true;
	
	if (is_mc_nugget2(n - 9))
		return true;


	return false;
}

// This is an "instrumented" version of the function.

bool is_mc_nugget_num(int n, int depth)
{ // return true iff n is a Mc Nugget Number
  // i.e., was can purchase exactly this number of Chicken Nuggets,
  // where the atomic orders are 4, 6, 9, 20

	cout << "is_mc_nugget_num(" << n << ", " << depth << ")" << endl;

	for (int i = 0; i < depth; i++)
		cout << "   ";
	cout << " " << n << endl;

	if ((n == 0) || (n % 4 == 0) || (n % 6 == 0) || 
		(n % 9 == 0) || (n % 20 == 0))
		return true;

	if (n < 4)
		return false;

	if (is_mc_nugget_num(n - 20, depth+1))
		return true;

	if (is_mc_nugget_num(n - 9, depth+1))
		return true;

	if (is_mc_nugget_num(n - 6, depth+1))
		return true;
	
	if (is_mc_nugget_num(n - 4, depth+1))
		return true;


	return false;
}

bool is_even(int i);

bool is_odd(int i)
{
	if (i == 0) return false;
	if (i == 1) return true; // If you comment this out, you can construct a segfault

	if (i > 0)
	{
		if (is_even(i-2))
			return false;
	}
	else
	{
		if (is_even(i+2))

			return false;
	}
	return true;

}

bool is_even(int i)
{
	if (i == 0) return true;
	if (i == 1) return false;

	if (i > 0)
	{
		if (is_odd(i-2))
			return false;
	}
	else
	{
		if (is_odd(i+2))

			return false;
	}
	return true;
}

int main()  // function were execution begins
{
	int num;

	while (true)
	{
		
		cout << "Input a number please: ";
		cin >> num;

		if (is_even(num))
			cout << num << " is even!" << endl;	
		else
			cout << num << " is odd!" << endl;

		if (is_mc_nugget_num(num,0))
			cout << "Yes, it is a tasty tasty number" << endl;
		else
			cout << "Nope" << endl;

	}


	return 0; // returning zero from main() indicates success
}




